using UnityEngine;

namespace CheesyFX
{
    public class CapsulePenetrator : Penetrator
    {
        private CapsuleCollider capsule;

        public CapsulePenetrator(CapsuleCollider capsule) : base(capsule)
        {
            // capsule.Print();
            this.capsule = capsule;
            SetTip();
        }

        public void SetTip()
        {
            switch (capsule.direction)
            {
                case 0:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = (capsule.height * .5f + capsule.radius) * scale*9f;
                    // 0.Print();
                    break;
                case 1:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = (capsule.height * .5f + capsule.radius) * scale*9f;
                    // 1.Print();
                    break;
                case 2:
                    tip.localPosition = new Vector3(capsule.radius * scale, 0f, 0f);
                    width = capsule.radius * scale*9f;
                    // 2.Print();
                    break;
            }
        }
    }
}