using System;
using System.Collections;
using UnityEngine;

namespace CheesyFX
{
    public class OrificeTriggerHandler : MonoBehaviour
    {
        public bool isActive;
        public Orifice orifice;
        public Collider lastColliding;
        
        Material lineMaterial = new Material(Shader.Find("Battlehub/RTGizmos/Handles"));
        
        public int numCollisions
        {
            get { return _numCollisions; }
            set
            {
                if (value > 0) _numCollisions = value;
                else
                {
                    _numCollisions = 0;
                    orifice.isPenetrated = false;
                    lastColliding = null;
                }
            }
        }
        private int _numCollisions;
		
        public void OnTriggerEnter(Collider collider)
        {
            // if (collider is MeshCollider)
            // {
            //     var renderer = collider.gameObject.GetComponent<SkinnedMeshRenderer>();
            //     if(renderer == null) renderer = collider.gameObject.AddComponent<SkinnedMeshRenderer>();
            //     lineMaterial.renderQueue = 3000;
            //     lineMaterial.SetFloat("_Offset",1f);
            //     lineMaterial.SetFloat("_MinAlpha", 1f);
            //     Color previewColor = Color.green;
            //     previewColor.a = 0.5f;
            //     lineMaterial.color = previewColor;
            //     renderer.material = lineMaterial;
            //     renderer.enabled = true;
            // }
            // collider.contactOffset.Print();
            if (collider.isTrigger || collider.attachedRigidbody.GetRegionName() == "pelvis")
            {
                return;
            }

            lastColliding = collider;
            numCollisions++;
            if (!enabled)
            {
                if (orifice.isPenetrated)
                {
                    orifice.isPenetrated = false;
                }
                return;
            }
            if (!orifice.isPenetrated)
            {
                orifice.RegisterCollision(collider);
            }
        }
		
        public void OnTriggerExit(Collider collider)
        {
            // if (collider is MeshCollider)
            // {
            //     var renderer = collider.gameObject.GetComponent<SkinnedMeshRenderer>();
            //     renderer.enabled = false;
            // }
            if (collider.isTrigger) return;
            numCollisions--;
        }

        private void OnDisable()
        {
            Reset();
        }

        public void Reset()
        {
            orifice.isPenetrated = false;
        }
    }
}