using UnityEngine;

namespace CheesyFX
{
    public class LerpableMorph
    	{
    		public DAZMorph dazMorph;
    		public float lipLift;
    		public float lLowerLidLift;
    		public float rLowerLidLift;
    		public float weight;
    		public float max;
            public bool isAtTarget = true;
    		public bool active;
    		public static float quicknessIn = 2f;
    		public static float quicknessOut = .5f;
    		public string name => dazMorph.displayName;
    		public string uid => dazMorph.uid;
    		private float _target;
    		public float target
    		{
    			get { return _target; }
    			set
    			{
    				if (_target == value) return;
    				_target = value;
    				isAtTarget = false;
    				if (value > 0f) active = true;
    			}
    		}
    
    		public float val
    		{
    			get { return dazMorph.morphValue; }
    			set
    			{
    				dazMorph.morphValue = value;
    				// dazMorph.morphValue = value;
    			}
    		}
    
    		public LerpableMorph(DAZMorph dazMorph)
    		{
    			this.dazMorph = dazMorph;
    		}
    
    		public void LerpToTarget()
    		{
    			if (isAtTarget) return;
    			if(Mathf.Abs(val - _target) < .0025f)
    			{
    				val = _target;
    				isAtTarget = true;
    				if (_target == 0f) active = false;
    				// if(uid.Contains("Eyeball")) val.Print();
    				return;
    			}
    			if(_target > 0) val = Mathf.Lerp(val, _target, quicknessIn*Time.deltaTime);
    			else val = Mathf.Lerp(val, _target, quicknessOut*Time.deltaTime);
    		}
    	}
}